﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public enum TypeSpawn {
    bat,
    moth
}
public class EnemyMovement : MonoBehaviour {
    public float _velocity;
    public Transform _target;
    // Use this for initialization
    public int _rangeMode;
    public float velRate;
    public SpriteRenderer sprite;
    public TypeSpawn type;
    public Manager ger;
    public float lifeTime;
    public float lifeLimit;

    public int randomAudio;
    public AudioClip[] clips;
    public AudioSource source;
    public int maxRangeClips;
    void Awake() {
       

    }
	void Start () {
        ger = Manager.Instance;
     
        _target = PlayerInstance.InstanceTransform;
        _rangeMode = Random.Range(0, 5);

            var dir = _target.transform.position - transform.position;
            var angle = Mathf.Atan2(dir.y, dir.x) * Mathf.Rad2Deg;
            transform.rotation = Quaternion.AngleAxis(angle, Vector3.forward);
            velRate = _velocity;

        randomAudio = Random.Range(0, maxRangeClips);
        source.PlayOneShot(clips[randomAudio]);
      
    }
	
	// Update is called once per frame
	void Update () {

        //transform.right = _target.position - transform.position;
       
        if (_rangeMode.Equals(0))
        {
            _velocity = velRate * 2;
            lifeTime += Time.deltaTime;
            var dir = _target.transform.position - transform.position;
                var angle = Mathf.Atan2(dir.y, dir.x) * Mathf.Rad2Deg;
                transform.rotation = Quaternion.AngleAxis(angle, Vector3.forward);
            if (lifeTime >= lifeLimit)
            {
                sprite.color = Color.red;
                gameObject.layer = 6;
                Destroy(gameObject, 0.1f);
            }

        }
        else if(_rangeMode.Equals(1)){
            lifeTime += Time.deltaTime;
            _velocity = velRate * 3;
            
                var dir = _target.transform.position - transform.position;
                var angle = Mathf.Atan2(dir.y, dir.x) * Mathf.Rad2Deg;
                transform.rotation = Quaternion.AngleAxis(angle, Vector3.forward);
            if (lifeTime>=lifeLimit) {
                sprite.color = Color.red;
                gameObject.layer = 6;
                Destroy(gameObject,0.1f);
            }
           
        }
        else if (_rangeMode.Equals(2))
        {
            _velocity = velRate * 3;
        }
        else if (_rangeMode.Equals(3))
        {
            _velocity = velRate * 4;
        }
        else if (_rangeMode.Equals(4))
        {
            _velocity = velRate * 3.5f;
        }

        transform.Translate(new Vector3(_velocity*Time.deltaTime,0, 0));

        
    }

    void OnTriggerEnter2D(Collider2D col) {
        if (col.gameObject.CompareTag("Limit")) {
            Destroy(gameObject);
        }
        if (col.gameObject.CompareTag("Player"))
        {
            if (type.Equals(TypeSpawn.bat))
            {
                sprite.color = Color.red;
                gameObject.layer = 6;
            }
            else {
                sprite.color = Color.yellow;
            }
            Destroy(gameObject,0.2f);
            Debug.Log("Destroyed");
        }

       
        if (type.Equals(TypeSpawn.bat)) {
            if (col.gameObject.CompareTag("Wave"))
            {
                if (!ger.SpecialActive)
                {
                    ger.AddSpecialPoints();
                }
                Destroy(gameObject, 0.2f);
                Debug.Log("Destroyed");
            }
        }
      
    }
    void OnDestroy() {
        if (type.Equals(TypeSpawn.bat))
        {
               
            gameObject.layer = 6;
          
            sprite.color = Color.red;
        }
    }
    void OnTriggerStay2D(Collider2D col) {
        if (col.gameObject.CompareTag("Sonar"))
        {
            gameObject.layer = 6;
            if (ger.SpecialActive && type.Equals(TypeSpawn.bat)) {
                Destroy(gameObject, 0.2f);
                ger.SpecialContReset();
            }
        }
   }
    void OnTriggerExit2D(Collider2D col)
    {
        if (col.gameObject.CompareTag("Sonar"))
        {
            gameObject.layer = 7;
            Debug.Log("Saiu");
        }
    }

}
